# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PublicKeyResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'alg': 'str',
        'value': 'str',
        'issuer': 'str',
        'keys': 'list[dict(str, object)]'
    }

    attribute_map = {
        'alg': 'alg',
        'value': 'value',
        'issuer': 'issuer',
        'keys': 'keys'
    }

    def __init__(self, alg=None, value=None, issuer=None, keys=None):  # noqa: E501
        """PublicKeyResponse - a model defined in Swagger"""  # noqa: E501
        self._alg = None
        self._value = None
        self._issuer = None
        self._keys = None
        self.discriminator = None
        if alg is not None:
            self.alg = alg
        if value is not None:
            self.value = value
        if issuer is not None:
            self.issuer = issuer
        if keys is not None:
            self.keys = keys

    @property
    def alg(self):
        """Gets the alg of this PublicKeyResponse.  # noqa: E501

        The algorithm associated with the public key.  # noqa: E501

        :return: The alg of this PublicKeyResponse.  # noqa: E501
        :rtype: str
        """
        return self._alg

    @alg.setter
    def alg(self, alg):
        """Sets the alg of this PublicKeyResponse.

        The algorithm associated with the public key.  # noqa: E501

        :param alg: The alg of this PublicKeyResponse.  # noqa: E501
        :type: str
        """

        self._alg = alg

    @property
    def value(self):
        """Gets the value of this PublicKeyResponse.  # noqa: E501

        The public key. Set in the case of <code>pem</code> format.  # noqa: E501

        :return: The value of this PublicKeyResponse.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this PublicKeyResponse.

        The public key. Set in the case of <code>pem</code> format.  # noqa: E501

        :param value: The value of this PublicKeyResponse.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def issuer(self):
        """Gets the issuer of this PublicKeyResponse.  # noqa: E501

        The issuer of the JWTs issued by the Identity service against which to validate the iss claim.  # noqa: E501

        :return: The issuer of this PublicKeyResponse.  # noqa: E501
        :rtype: str
        """
        return self._issuer

    @issuer.setter
    def issuer(self, issuer):
        """Sets the issuer of this PublicKeyResponse.

        The issuer of the JWTs issued by the Identity service against which to validate the iss claim.  # noqa: E501

        :param issuer: The issuer of this PublicKeyResponse.  # noqa: E501
        :type: str
        """

        self._issuer = issuer

    @property
    def keys(self):
        """Gets the keys of this PublicKeyResponse.  # noqa: E501

        The list of the currently valid public keys. Set in the case of <code>jwks</code> format. The model of this property is a <code>Map</code> of <code>JsonWebKey</code> objects.  # noqa: E501

        :return: The keys of this PublicKeyResponse.  # noqa: E501
        :rtype: list[dict(str, object)]
        """
        return self._keys

    @keys.setter
    def keys(self, keys):
        """Sets the keys of this PublicKeyResponse.

        The list of the currently valid public keys. Set in the case of <code>jwks</code> format. The model of this property is a <code>Map</code> of <code>JsonWebKey</code> objects.  # noqa: E501

        :param keys: The keys of this PublicKeyResponse.  # noqa: E501
        :type: list[dict(str, object)]
        """

        self._keys = keys

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PublicKeyResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PublicKeyResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
